;*****************************************************************************
;*                                                                           *
;*                                                                           *
;*       WEIHNACHTS-LED-DEKORATION                                           *
;*       =========================                                           *
;*                                                                           *
;*                                                                           *
;*       DER QUARZ HAT 8MHZ ALSO T=0.125SEC  T==TAKTZEIT    T=1:F          *
;*                                                                           *
;*****************************************************************************
;*                                                                           *
;*                           BEGINN: 23.12.18                                *
;*                           ENDE  :                                         *
;*                                                                           *
;*****************************************************************************
    LIST    P=16F877A   
    TITLE   "WEIHNACHTS-DEKO"

    INCLUDE <P16F877A.INC>
    ERRORLEVEL -302


__CONFIG  _HS_OSC & _WDT_OFF & _PWRTE_OFF & _CP_OFF & _BODEN_ON & _LVP_OFF & _CPD_OFF 

;BEI BODEN_ON ERFOLGT POWER-ON RESET, WENN DIE SPEISESPANNUNG KURZ MAL UNTER 4,0VOLT FLLT
;ES HNGT SICH DER PIC NICHT BEI KURZEN STROMAUSFLLEN AUF !!!! AUCH BEI SCHNELLEM EIN- UND AUS-SCHALTEN DER SPEISESPANNUNG

;PORTZUORDNUNG==>

;EING.  PORTA   AN0 POTI     -GESCHWINDIGKEIT ALSO ABLAUF WIE SCHNELL DIE LED-RINGE WECHSELN
;EING.  PORTA   AN1 POTI     -DAUER BEIM WECHSELN IN EINE ANDERE MODI ALSO WIE LANGE EINE MODI ANGEZEIGT WIRD
;EING.  PORTA   RA2 TASTER   -UM DIE EINZELNEN MODI EINZUSTELLEN (HOCHZHLEN) BEI DAUER-BETRIEB
;EING.  PORTA   RA4 SCHALTER -DAUERBETRIEB ODER AUTOMATISCHER WECHSELBETRIEB DER EINZELNEN MODI-BETRIEBSARTEN
;EING.  PORTA   RA3 NICHT ANGESCHLOSSEN
;EING.  PORTA   RA5 NICHT ANGESCHLOSSEN
;
;PORTB LED BESCHALTUNG SIEHE STROMLAUFPLAN
;PORTC LED BESCHALTUNG SIEHE STROMLAUFPLAN
;PORTD LED BESCHALTUNG SIEHE STROMLAUFPLAN
;PORTE LED BESCHALTUNG SIEHE STROMLAUFPLAN

;---------------------------------------------------------------------------------
;VARIABLEN
BIT0            EQU 0
BIT1            EQU 1
BIT2            EQU 2
BIT3            EQU 3
BIT4            EQU 4
BIT5            EQU 5
BIT6            EQU 6
BIT7            EQU 7

MODI_MAX_WERT   EQU     D'5'   ;IMMER +1 / ALSO BEI 5 MODIS DIE ZAHL 6 EINTRAGEN
;==================================================



;----------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ALSO RAM-SPEICHER ZUORDNUNG

HELP            EQU 0X22    ;FR ZEITSCHLEIFE
HELP1           EQU 0X23    ;FR ZEITSCHLEIFE

AD0_H           EQU 0X24    ;AD-WERT HIGH FR AN0
AD0_L           EQU 0X25    ;AD-WERT LOW FR AN0

PRE             EQU 0X26    ;BEI GEDRCKTEM TASTER UND LOSLASSEN VON RA2 BIT0=HIGH TASTENDRUCK-MERKER
MERK            EQU 0X27    ;BEIM PRELLEN HILFSZELLE
MOD_NR          EQU 0X28    ;MODI-NUMMER VON 1 BIS ...

;BEIM DIMMEN
ZYKLUS          EQU 0X29    ;BIT0 BEI HIGH VON DUNKEL ZU HELLER / AUFWRTS DIMMEN  ///  BIT7 BEI HIGH INTERRUPT-ZEIT MITTELS TIMER1 ZU ENDE
                            ;BIT5 BEI HIGH AD-ERGEBNIS IST LINKSBNDIG
HELL0_L         EQU 0X2A
HELL0_H         EQU 0X2B
DUNKEL0_L       EQU 0X2C
DUNKEL0_H       EQU 0X2D
HELL_L          EQU 0X2E
HELL_H          EQU 0X2F
DUNKEL_L        EQU 0X30
DUNKEL_H        EQU 0X31

ZAE1            EQU 0X32    ;ZAEHLER FR 40SEC AD_WANDLER
W_STACK         EQU 0X33
S_STACK         EQU 0X34

;EEPROM-MERKER
ADR             EQU 0X35
E_SPEI          EQU 0X36

;------------------------- MACROS -----------------------------------------

BANK0           MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                BCF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK1           MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                BSF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK2           MACRO                   ;MACRO TO SELECT DATA RAM BANK 2
                BCF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

BANK3           MACRO                   ;MACRO TO SELECT DATA RAM BANK 3
                BSF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;SPEICHERANFANG BZW. BEGINN

                ORG 0X0000
                GOTO MAIN               ; SPRUNG ZUM HAUPTPROGRAMM
                ORG 0X0004
                GOTO INTERRUPT 

                ORG 0X0010

;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              20.10.17                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN            CLRF    PORTA                           
                CLRF    PORTB
                CLRF    PORTC                           
                CLRF    PORTD
                CLRF    PORTE                         

                BANK1
                MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
                MOVWF   CMCON

                MOVLW   B'11111111'             ;INIT I/O PORTA  ALLES EINGANG BIT0 BIS 5 /AD AN0 UND AD AN1 
                MOVWF   TRISA
                MOVLW   B'00000000'             ;INIT I/O PORTB  ALLES AUSGANG 
                MOVWF   TRISB
                MOVLW   B'00000000'             ;INIT I/O PORTC  ALLES AUSGANG 
                MOVWF   TRISC
                MOVLW   B'00000000'             ;INIT I/O PORTD  ALLES AUSGANG 
                MOVWF   TRISD
                MOVLW   B'00000000'             ;INIT I/O PORTE  ALLES AUSGANG 
                MOVWF   TRISE


;AD-INIT
                MOVLW   B'11000100'  ;RECHTSBNDIG B1 / FOSZ=16 B1 / XX / B0100 VSS+VDD REF-SPANNUNG NUR AN0 AN1 AN3
                MOVWF   ADCON1

                BANK0
;AD-INIT
                MOVLW   B'01000001'  ;FOSZ=16 B01 / AN0 B000 (JETZT) ODER AN1 B001 / GO-IST AUS + ON IST EIN   B0X1
                MOVWF   ADCON0

;INIT TIMER 1 
                MOVLW   B'00000000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [00]1:1 VORERST 0
                MOVWF   T1CON

;50MSEC ZEITSCHLEIFE
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN IN W MIT DEZIMAL 5 ALSO---> 5*10MSEC=50MSEC
                CALL    ZS1MSEC   

;---------------------------------------------------------------------
;BEI ZU ERSTEM MAL NACH BRENNEN HIER MIT SCHALTZEIT EEPROM BESCHREIBEN
            MOVLW   0X10
            MOVWF   ADR
            CALL    E_READ

                SUBLW   0X13        
                BTFSC   STATUS, Z       ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
                GOTO    FASL
;---

;KENNUNGSBYTE BEIM ERSTEN STRAT
            MOVLW   0X10
            MOVWF   ADR
            MOVLW   0X13 ;KENNUNGSBYTE
            MOVWF   E_SPEI

            CALL    E_WRITE

;BESCHREIBEN FR EIN
            MOVLW   0X01 ;MODI 1
            MOVWF   MOD_NR
            MOVWF   E_SPEI

            MOVLW   0X00
            MOVWF   ADR
            CALL    E_WRITE
            GOTO    MODI1
;---
;---
FASL        MOVLW   0X00
            MOVWF   ADR
            CALL    E_READ

            MOVWF   MOD_NR

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


MODI1
                BCF     PRE, BIT0        ;TASTE RA2 GEDRCKT RCKSETZEN
 
;MODI-NUMMER SUCHEN / EINSTELLEN
                MOVLW   D'1'             
                SUBWF   MOD_NR, W        

                BTFSS   STATUS, Z        
                GOTO    MODI2            ;UNGLEICH
                
;LEDS LEUCHTEN
                CALL    RING1_EIN
                CALL    RING2_EIN
                CALL    RING3_EIN
                CALL    RING4_EIN
                CALL    RING5_EIN
                CALL    RING6_EIN
                CALL    RING7_EIN

;XSEC ZEITSCHLEIFE
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD1
                BTFSC   PRE, BIT0
                GOTO    MODI1

;LEDS LEUCHTEN NICHT
                CALL    RING1_AUS
                CALL    RING2_AUS
                CALL    RING3_AUS
                CALL    RING4_AUS
                CALL    RING5_AUS
                CALL    RING6_AUS
                CALL    RING7_AUS

;XSEC ZEITSCHLEIFE
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN
                CALL    ZS10MSEC_1
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD1
                GOTO    MODI1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODI2
;MODI-NUMMER SUCHEN / EINSTELLEN
                MOVLW   D'2'             
                SUBWF   MOD_NR, W       

                BTFSS   STATUS, Z        
                GOTO    MODI3            ;UNGLEICH

;LEDS AM ANFANG AUS MACHEN
                CALL    RING1_AUS
                CALL    RING2_AUS
                CALL    RING3_AUS
                CALL    RING4_AUS
                CALL    RING5_AUS
                CALL    RING6_AUS
                CALL    RING7_AUS

;ES GEHT LOS MIT EIN-SCHALTEN
                CALL    RING1_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING2_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING3_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING4_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING5_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING6_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING7_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1


;ES GEHT MIT AUS-SCHALTEN WEITER
                CALL    RING7_AUS
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING6_AUS
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING5_AUS
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING4_AUS
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING3_AUS
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING2_AUS
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING1_AUS
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                GOTO    MODI2                

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MODI3
;MODI-NUMMER SUCHEN / EINSTELLEN
                MOVLW   D'3'             
                SUBWF   MOD_NR, W       

                BTFSS   STATUS, Z        
                GOTO    MODI4            ;UNGLEICH

;LEDS AM ANFANG AUS MACHEN
                CALL    RING1_AUS
                CALL    RING2_AUS
                CALL    RING3_AUS
                CALL    RING4_AUS
                CALL    RING5_AUS
                CALL    RING6_AUS
                CALL    RING7_AUS

;ES GEHT LOS MIT EIN-SCHALTEN
                CALL    RING1_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING1_AUS
                CALL    RING2_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING2_AUS
                CALL    RING3_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING3_AUS
                CALL    RING4_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING4_AUS
                CALL    RING5_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING5_AUS
                CALL    RING6_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING6_AUS
                CALL    RING7_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1


;ES GEHT MIT AUS-SCHALTEN WEITER
;;;;;;;;;;;;;;
                CALL    RING7_AUS
                CALL    RING6_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING6_AUS
                CALL    RING5_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING5_AUS
                CALL    RING4_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING4_AUS
                CALL    RING3_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING3_AUS
                CALL    RING2_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING2_AUS
                CALL    RING1_EIN
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                CALL    RING1_AUS
                MOVLW   D'50'                   ;ZEITSCHLEIFE LADEN 
                CALL    ZS10MSEC_1   
                CALL    AD0                     ;GESCHWINDIGKEIT EINSTELLBAR MACHEN
                CALL    GESCHW_MOD2
                BTFSC   PRE, BIT0
                GOTO    MODI1
;;;;;;;;;;;;;;
                GOTO    MODI3      



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MODI4
;MODI-NUMMER SUCHEN / EINSTELLEN
                MOVLW   D'4'             
                SUBWF   MOD_NR, W       

                BTFSS   STATUS, Z        
                GOTO    MODI1            ;UNGLEICH


                CLRF    ZYKLUS          ;BEGINN MIT HOCH DIMMEN / VON DUNKEL ZU HELLER /// LINKSBNDIG NOCH NICHT /// ENDE RA2-TASTER NOCH NICHT

START       BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    START
 
                BCF     ZYKLUS, BIT7        ;ENDE ZEIT-INTERRUPT MERKER RCKSTELLEN

                BTFSS   ZYKLUS, BIT0
                GOTO    START1
                BCF     ZYKLUS, BIT0
                GOTO    START2
START1          BSF     ZYKLUS, BIT0

START2          BTFSS   ZYKLUS, BIT0
                GOTO    ZY1

                MOVLW   0X10
                MOVWF   HELL0_L
                CLRF    HELL0_H
   
                MOVLW   0XE0
                MOVWF   DUNKEL0_L
                MOVLW   0X03
                MOVWF   DUNKEL0_H
                GOTO    ZY2

ZY1             MOVLW   0X10
                MOVWF   DUNKEL0_L
                CLRF    DUNKEL0_H
   
                MOVLW   0XE0
                MOVWF   HELL0_L
                MOVLW   0X03
                MOVWF   HELL0_H

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;INTERRUPT ZULASSEN
ZY2             BSF     INTCON, GIE     ;ALLGEMEINES INTERRUPT ENABLE
                BSF     INTCON, PEIE
                BANK1
                BSF     PIE1, TMR1IE    ;OVERFLOW INTERRUPT BEI TIMER1 ZULASSEN/ENABLE
                BANK0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    BTFSS   ZYKLUS, BIT0   ;HIGH ENTSPRICHT HOCH FAHREN
                    GOTO    ZYY1

;LANGSAME ZEIT ///ALTE ZEIT
    MOVLW 0X00          
                MOVWF   AD0_L
                MOVWF   TMR1L
       
    MOVLW 0XD8 ;geaendert lansamer vorher 0xe8
                MOVWF   AD0_H
                MOVWF   TMR1H
                GOTO    ZYY2

;SCHNELLERE ZEIT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ZYY1    MOVLW 0X00 ;ALT 0X00    !!!HIER NEUE ZEIT ALSO SCHNELLER !!!DOPPELT SO SCHNELL
                MOVWF   AD0_L
                MOVWF   TMR1L
       
        MOVLW 0XF0 ;ALT 0XE8 war 0xf4 
                MOVWF   AD0_H
                MOVWF   TMR1H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ZYY2
                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN
                BSF     T1CON, TMR1ON   ;START DES TIMER1

;---------------INITIALISIERUNG--ZU--ENDE-----------------------


;---------------------------------------------------------------

ANF         BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    ANF 

                        MOVF    HELL0_L, W
                        MOVWF   HELL_L                 
                        MOVF    HELL0_H, W
                        MOVWF   HELL_H

            BSF     INTCON, GIE        ;INTERRUPT WIEDER ZULASSEN

;LEDS LEUCHTEN
                CALL    RING1_EIN
                CALL    RING2_EIN
                CALL    RING3_EIN
                CALL    RING4_EIN
                CALL    RING5_EIN
                CALL    RING6_EIN
                CALL    RING7_EIN

WEITER1                 NOP         
                        NOP
                        NOP
                        NOP
                        NOP
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP

                        NOP
                        NOP         ;10NOPS * 0,5SEC= 5SEC
 
                        MOVLW   D'1'            
                        SUBWF   HELL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1
                        MOVLW   D'1'
                        SUBWF   HELL_H, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1         

;------------------------------- 
SE1         BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    SE1
 
                        MOVF    DUNKEL0_L, W
                        MOVWF   DUNKEL_L                 
                        MOVF    DUNKEL0_H, W
                        MOVWF   DUNKEL_H   

            BSF     INTCON, GIE        ;INTERRUPT WIEDER ZULASSEN

;LEDS LEUCHTEN NICHT
                CALL    RING1_AUS
                CALL    RING2_AUS
                CALL    RING3_AUS
                CALL    RING4_AUS
                CALL    RING5_AUS
                CALL    RING6_AUS
                CALL    RING7_AUS

WEITER2                 NOP         
                        NOP
                        NOP
                        NOP
                        NOP
 
                        NOP
                        NOP
                        NOP
                        NOP
                        NOP

                        NOP
                        NOP         ;10NOPS * 0,5SEC= 5SEC
 
                        MOVLW   D'1'            
                        SUBWF   DUNKEL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2
                        MOVLW   D'1'
                        SUBWF   DUNKEL_H, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2         

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        BTFSC   ZYKLUS, BIT7   
                        GOTO    START       ;EIN DURCHLAUF (VON DUNKEL ZU HELL) ZU ENDE

                        CALL    PRELL_RA2   ;HIER NEUE MODI MIT RA2 TASTER
                        BTFSS   PRE, BIT0
                        GOTO    ANF         ;EINE FREQUENZ-PERIODE MIT LEUCHTEN + NICHT LEUCHTEN ZU ENDE (ALSO 1023MAL*0,5SEC=0,5MSEC)

WEITER_A    BCF     INTCON, GIE             ;INTERRUPT SPERREN 
            BTFSC   INTCON, GIE
            GOTO    WEITER_A

            GOTO    MODI1


;*****************************************************************************
;*                              INTERRUPT                                    *
;*                              04.06.12                                     *
;*****************************************************************************
INTERRUPT       PUSH
                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                MOVF    AD0_L, W        
                MOVWF   TMR1L       
                MOVF    AD0_H, W
                MOVWF   TMR1H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                BTFSS   ZYKLUS, BIT0
                GOTO    ZZY1

                MOVLW   D'1'            ;HOCH FAHREN / HELLER MACHEN //// ZYKLUS-BIT0 HIGH
                SUBWF   DUNKEL0_L, F
                BTFSC   STATUS, C
                GOTO    INT1
                DECF    DUNKEL0_H, F

INT1            INCFSZ  HELL0_L, F
                GOTO    INT2
                INCF    HELL0_H, F

;SCHNELLERE / KRZERE ZEIT TIMER1 AB 0X0200 GEGEN DEM ENDE BEIM HOCH-FAHREN / HELLER MACHEN
                MOVLW   0X02            ;SCHNELLER AB 0X0200 --> HELL0_H ALSO 0X02                   
                SUBWF   HELL0_H, W
                BTFSS   STATUS, Z       ;BEI ZERO = HIGH GLEICH ALS 0X0200
                GOTO    INTC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    MOVLW 0X00 ;ALT 0X00    !!!HIER NEUE ZEIT ALSO SCHNELLER !!!DOPPELT SO SCHNELL
                MOVWF   AD0_L
                MOVWF   TMR1L
       
    MOVLW 0XF0 ;ALT 0XE8 
                MOVWF   AD0_H
                MOVWF   TMR1H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

INT2            MOVLW   0XE0            ;ENDE BEI 0X03FE -- HELL0                   
                SUBWF   HELL0_L, W
                BTFSS   STATUS, Z
                GOTO    INTC

                MOVLW   0X03                   
                SUBWF   HELL0_H, W
                BTFSS   STATUS, Z
                GOTO    INTC
                BSF     ZYKLUS, BIT7    ;AUF + ABSCHWELLEN EINSTELLEN MERKEN INT ZU ENDE
                GOTO    INTD 


;----
ZZY1            MOVLW   D'1'            ;RUNTER FAHREN / DUNKLER MACHEN //// ZYKLUS-BIT0 LOW            
                SUBWF   HELL0_L, F
                BTFSC   STATUS, C
                GOTO    INTA
                DECF    HELL0_H, F

INTA            INCFSZ  DUNKEL0_L, F
                GOTO    INTB
                INCF    DUNKEL0_H, F

;LANGSAMER / GRERE ZEIT TIMER1 AB 0X0200 GEGEN DEM ENDE BEIM RUNTER-FAHREN / DUNKLER MACHEN
                MOVLW   0X02            ;SCHNELLER AB 0X0200 --> HELL0_H ALSO 0X02                   
                SUBWF   DUNKEL0_H, W
                BTFSS   STATUS, Z       ;BEI ZERO = HIGH GLEICH ALS 0X0200
                GOTO    INTC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    MOVLW 0X00 ;ALT 0X00   !!!HIER ALTE ZEIT ALSO LANGSAMER
                MOVWF   AD0_L
                MOVWF   TMR1L
       
    MOVLW 0XD8 ;ALT 0XE8 ;geaendert lansamer vorher 0xe8
                MOVWF   AD0_H
                MOVWF   TMR1H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

INTB            MOVLW   0XE0            ;ENDE BEI 0X03FE -- DUNKEL0                   
                SUBWF   DUNKEL0_L, W
                BTFSS   STATUS, Z
                GOTO    INTC

                MOVLW   0X03                   
                SUBWF   DUNKEL0_H, W
                BTFSS   STATUS, Z
                GOTO    INTC
                BSF     ZYKLUS, BIT7    ;AUF + ABSCHWELLEN EINSTELLEN MERKEN INT ZU ENDE

                ;MOVLW   D'20'           ;KURZE ZEIT GANZ DUNKEL
                ;CALL    ZS1MSEC

                GOTO    INTD 
;---  

INTC            BSF     T1CON, TMR1ON   ;START DES TIMER1
INTD            POP
                RETFIE


;*****************************************************************************
;*                              EEPROM READ PIC16F678 OHNE A                 *
;* ADR                                                                        *
;*****************************************************************************
;DIE EEPROMADRESSE MUSS IN ADR STEHEN UND IMMER ERHHT WERDEN ...
;DAS ERGEBNIS DES WERTES VOM EEPROM-INHALT STEHT AM ENDE IN W

E_READ
                MOVF    ADR, W
                BANK2
                MOVWF   EEADR

                BANK3
                BCF     EECON1, EEPGD
                BSF     EECON1, RD

                BANK2
                MOVF    EEDATA, W
                BANK0
                RETURN

;*****************************************************************************
;*                              EEPROM WRITE PIC16F678 OHNE A                *
;* E_SPEI                                                                    *
;* ADR                                                                        *
;*****************************************************************************
;DIE EEPROMADRESSE MUSS IN ADR STEHEN UND IMMER ERHHT WERDEN ...
;DAS ZU SPEICHERNDE BYTE IN E_SPEI STEHEN

E_WRITE
;ONLY DISABLE INTERRUPTS
                ;BCF     INTCON, GIE     ;INTERRUPT SPERREN
                ;BTFSC   INTCON, GIE
                ;GOTO    E_WRITE

                BCF     PIR2, EEIF      ;LSCHEN BIT

                MOVF    ADR, W

                BANK2
                MOVWF   EEADR

                BANK0
                MOVF    E_SPEI, W
                BANK2
                MOVWF   EEDATA

                BANK3
                BCF     EECON1, EEPGD   ;POINT TO DATA MEMORY
                BSF     EECON1, WREN    ;ENABLE WRITES

                MOVLW   0X55            ;WRITE 55H TO
                MOVWF   EECON2          ;EECON2
                MOVLW   0XAA            ;WRITE AAH TO
                MOVWF   EECON2          ;EECON2
                BSF     EECON1, WR      ;START WRITE OPERATION

                BCF     EECON1, WREN    ;DISABLE WRITES

                BANK0

FE_W2           BTFSS   PIR2, EEIF      ;SCHREIBEN ZU ENDE ?
                GOTO    FE_W2
                

;ONLY ENABLE INTERRUPTS
                ;BSF     INTCON, GIE     ;IF USING INTERRUPTS,
                RETURN


;*****************************************************************************
;*             GESCHWINDIGKEIT FR MODI 2 BERECHNEN                          *
;*****************************************************************************
GESCHW_MOD2
                RRF     AD0_H, F    ;MAX. 0X03FF (1024DEZ) ZU 512DEZ.
                RRF     AD0_L, F

                BCF     STATUS, C   ;CARRY LSCHEN
                RRF     AD0_H, F    ;MAX. 512DEZ. ZU 256DEZ.
                RRF     AD0_L, F

                BCF     STATUS, C   ;CARRY LSCHEN
                ;RRF     AD0_H, F    ;MAX. 256DEZ. ZU 128DEZ.
                ;RRF     AD0_L, F

;FUER GLEICH NULL GEMESSEN / ES PASSIERT UNSINN --->
                MOVLW   D'0'            ;IN W DEZ. 0 LADEN
                SUBWF   AD0_L, W        ;AD0_L - W(D'0') =>ERGEBNIS IN W / AD0_L BLEIBT ERHALTEN

                BTFSS   STATUS, Z       ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
                GOTO    GESCHW_MOD2_1   ;UNGLEICH

                MOVLW   D'1'            ;MUSS WENIGSTENS 1 SEIN
                MOVWF   AD0_L

;INIT TIMER 0 FR 5MSEC
GESCHW_MOD2_1
                        BANK1
                        MOVLW   B'10000101'             ;BIT0-2 1=PRESCALER64, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG
                        BANK0

BZZS11                  MOVLW   D'100'                  ;FR 5MSEC
                        MOVWF   TMR0                   
                        BCF     INTCON, TMR0IF          
                
BZZS12                  BTFSC   INTCON, TMR0IF
                        GOTO    BZZS13

                        CALL    PRELL_RA2
                        BTFSS   PRE, BIT0
                        GOTO    BZZS12                   
                        RETURN

BZZS13          DECFSZ  AD0_L, F        ;5MSEC * 256(MAX.AD0)=1,28SEC
                GOTO    BZZS11          ;MAX. 1,28SEC + DIE 500MSEC VON OBEN ALS KLEINSTER WERT = 1,78SEC ALS MAX.

                RETURN

;*****************************************************************************
;*             GESCHWINDIGKEIT FR MODI 1 BERECHNEN                          *
;*****************************************************************************
GESCHW_MOD1
                RRF     AD0_H, F    ;MAX. 0X03FF (1024DEZ) ZU 512DEZ.
                RRF     AD0_L, F

                BCF     STATUS, C   ;CARRY LSCHEN
                RRF     AD0_H, F    ;MAX. 512DEZ. ZU 256DEZ.
                RRF     AD0_L, F

                BCF     STATUS, C   ;CARRY LSCHEN
                ;RRF     AD0_H, F    ;MAX. 256DEZ. ZU 128DEZ.
                ;RRF     AD0_L, F

;FUER GLEICH NULL GEMESSEN / ES PASSIERT UNSINN --->
                MOVLW   D'0'            ;IN W DEZ. 0 LADEN
                SUBWF   AD0_L, W        ;AD0_L - W(D'0') =>ERGEBNIS IN W / AD0_L BLEIBT ERHALTEN

                BTFSS   STATUS, Z       ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
                GOTO    GESCHW_MOD1_1   ;UNGLEICH

                MOVLW   D'1'            ;MUSS WENIGSTENS 1 SEIN
                MOVWF   AD0_L

;INIT TIMER 0 FR 10MSEC
GESCHW_MOD1_1
                        BANK1
                        MOVLW   B'10000101'             ;BIT0-2 1=PRESCALER64, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG
                        BANK0

AZZS10                  MOVLW   D'2'
                        MOVWF   HELP

AZZS11                  MOVLW   D'100'                  ;FR 5MSEC * 2 = 10MSEC
                        MOVWF   TMR0                   
                        BCF     INTCON, TMR0IF          
                
AZZS12                  BTFSC   INTCON, TMR0IF
                        GOTO    AZZS13

                        CALL    PRELL_RA2
                        BTFSS   PRE, BIT0
                        GOTO    AZZS12                   
                        RETURN

AZZS13                  DECFSZ  HELP, F               
                        GOTO    AZZS11                  
  
                DECFSZ  AD0_L, F        ;10MSEC * 256(MAX.AD0)=2,56SEC
                GOTO    AZZS10          ;MAX. 2,56SEC + DIE 500MSEC VON OBEN ALS KLEINSTER WERT = 3,06SEC ALS MAX.

                RETURN
;*****************************************************************************
;*             AD-ABFRAGE AM EINSTELLREGLER AN0 ALS GESCHINDIGKEIT           *
;*****************************************************************************
AD0
                ;BTFSS   ZYKLUS, BIT5
                ;GOTO    RECHTS

;AD-INIT        
;                BANK1
;                MOVLW   B'01000100'  ;LINKSSBNDIG B0 / FOSZ=16 B1 / XX / B0100 VSS+VDD REF-SPANNUNG NUR AN0 AN1 AN3
;                MOVWF   ADCON1
;                BANK0

;AD02            
                BCF     PIR1, ADIF

;AD-INIT UND EIN (GO)
                MOVLW   B'01000101'  ;FOSZ=16 B01 / AN0 B000 (JETZT) / GO-IST EIN + ON IST EIN   B1X1
                MOVWF   ADCON0
                CALL    MUE40

AD01            BTFSS   PIR1, ADIF
                GOTO    AD01

                MOVF    ADRESH, W
                MOVWF   AD0_H

                BANK1
                MOVF    ADRESL, W
                BANK0
                MOVWF   AD0_L

;AD-INIT UND AUS (DONE)
                MOVLW   B'01000001'  ;FOSZ=16 B01 / AN0 B000 (JETZT) / GO-IST AUS + ON IST EIN   B0X1
                MOVWF   ADCON0

                RETURN

;AD-INIT
;RECHTS
 ;               BANK1
 ;               MOVLW   B'11000100'  ;RECHTSSBNDIG B1 / FOSZ=16 B1 / XX / B0100 VSS+VDD REF-SPANNUNG NUR AN0 AN1 AN3
 ;               MOVWF   ADCON1
 ;               BANK0
 ;               GOTO    AD02

;*****************************************************************************
;*             WENN TASTER AN RA2 GEDRCKT UND WIEDER LOSGELASSEN WIRD       *
;*****************************************************************************
PRELL_RA2
                        BTFSC   PORTA, BIT2     ;RA2 TASTERABFRAGE HIER GEDRCKT
                        RETURN

                        MOVLW   D'20'           ;20MSEC PRELLEN BEIM DRCKEN / STARR
                        CALL    ZS1MSEC

PRELL_02                BTFSS   PORTA, BIT2     ;RA2 TASTERABFRAGE HIER LOSGELASSEN
                        GOTO    PRELL_02

                        MOVLW   D'20'           ;20MSEC PRELLEN BEIM LOSLASSEN MIT ABFRAGE
                        MOVWF   MERK

PRELL_01                MOVLW   D'1'
                        CALL    ZS1MSEC

                        BTFSS   PORTA, BIT2
                        GOTO    PRELL_02

                        DECFSZ  MERK, F
                        GOTO    PRELL_01

;!!!!!!!!!!!!!!
                        BSF     PRE, BIT0

;MODI-NUMMER 1 WEITER
                INCF    MOD_NR, F

                MOVLW   MODI_MAX_WERT   ;IN W DEZ. 3 (MAX. MODI_NUMMER +1) LADEN
                SUBWF   MOD_NR, W       ;MOD_NR - W(D'0') =>ERGEBNIS IN W / MOD_NR BLEIBT ERHALTEN

                BTFSS   STATUS, Z       ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
                GOTO    ASA1            ;BEI UNGLEICH

                MOVLW   D'1'            ;MINIMALE MODI-NUMMER
                MOVWF   MOD_NR


ASA1        MOVF    MOD_NR, W
            MOVWF   E_SPEI

            MOVLW   0X00
            MOVWF   ADR
            CALL    E_WRITE
            RETURN

;*****************************************************************************
;*                              1MSEC ZEITSCHLEIFE                           *
;*****************************************************************************
ZS1MSEC                 
                        MOVWF   HELP

;INIT TIMER 0
                BANK1
                MOVLW   B'10000101'             ;BIT0-2 1=PRESCALER64, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG
                BANK0

ZS11                    MOVLW   D'225'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 225 GELADEN
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
ZS12                    BTFSS   INTCON, TMR0IF          ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    ZS12                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC ZAE, F"..... VORHER ANDERES ABARBEITEN

                        DECFSZ  HELP, F                 ;ES WIRD DER WERT IN "HELP" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    ZS11                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;ZEITBERECHNUNG FUER 1MS
;ACHTUNG HIER BERECHNUNG FR 4MHZ / JETZT 8MHZ ABER PRESCALER 64X

;PRESCALER 32X  *  SYSTEM 4X  * TAKTZEIT ====> 32*4*0.25S=32SEC /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;1MSEC : 32SEC= 31,25  GENOMMEN 31                                   /T = 1 : F  (F)-OSZILLATORFREQUENZ HIER 16MHZ
;ALSO 
;32S*D'31'=0,992MSEC
;TMR0 ALSO D'256'-D'31'=D'225' ENTSPRICHT CA. 1MSEC

;*****************************************************************************
;*                              10MSEC ZEITSCHLEIFE                          *
;*****************************************************************************
;ZS10MSEC                 
;                        MOVWF   HELP

;INIT TIMER 0
;                BANK1
;                MOVLW   B'10000101'             ;BIT0-2 1=PRESCALER64, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
;                MOVWF   OPTION_REG
;                BANK0

;ZZS10                   MOVLW   D'2'
;                        MOVWF   HELP1

;ZZS11                   MOVLW   D'100'
;                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 225 GELADEN
;                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
;ZZS12                   BTFSS   INTCON, TMR0IF          ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
;                        GOTO    ZZS12                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC ZAE, F"..... VORHER ANDERES ABARBEITEN

;                        DECFSZ  HELP1, F                 ;ES WIRD DER WERT IN "HELP" ABWRTS GEZHLT, BIS ER (0) IST UND
;                        GOTO    ZZS11                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

;                        DECFSZ  HELP, F
;                        GOTO    ZZS10    

;                        RETURN

;ZEITBERECHNUNG FUER 5MS
;ACHTUNG HIER BERECHNUNG FR 4MHZ / JETZT 8MHZ ABER PRESCALER 64X

;PRESCALER 32X  *  SYSTEM 4X  * TAKTZEIT ====> 32*4*0.25S=32SEC /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;5MSEC : 32SEC= 156,25  GENOMMEN 156                                   /T = 1 : F  (F)-OSZILLATORFREQUENZ HIER 16MHZ
;ALSO 
;32S*D'156'=4,992MSEC
;TMR0 ALSO D'256'-D'156'=D'100' ENTSPRICHT CA. 5MSEC

;2 DRUCHLUFE ERGEBEN 10MSEC MIT HELP1=2...

;*****************************************************************************
;*                              10MSEC ZEITSCHLEIFE                          *
;*****************************************************************************
ZS10MSEC_1                 
                        MOVWF   HELP

;INIT TIMER 0
                BANK1
                MOVLW   B'10000101'             ;BIT0-2 1=PRESCALER64, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG
                BANK0

YZZS10                  MOVLW   D'2'
                        MOVWF   HELP1

YZZS11                  MOVLW   D'100'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 225 GELADEN
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
YZZS12                  BTFSC   INTCON, TMR0IF          ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    YZZS13                  ;ES ERFOLGT EIN SPRUNG ZU "DECFSC ZAE, F"..... VORHER ANDERES ABARBEITEN

                        CALL    PRELL_RA2
                        BTFSS   PRE, BIT0
                        GOTO    YZZS12                   
                        RETURN

YZZS13                  DECFSZ  HELP1, F                 ;ES WIRD DER WERT IN "HELP" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    YZZS11                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        DECFSZ  HELP, F
                        GOTO    YZZS10    

                        RETURN
;*****************************************************************************
;*                              100MSEC ZEITSCHLEIFE                         *
;*****************************************************************************
;ZS100MSEC                 
;                        MOVWF   HELP

;INIT TIMER 0
;                BANK1
;                MOVLW   B'10000101'             ;BIT0-2 1=PRESCALER64, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
;                MOVWF   OPTION_REG
;                BANK0

;ZZZS10                  MOVLW   D'20'
;                        MOVWF   HELP1

;ZZZS11                  MOVLW   D'100'
;                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 225 GELADEN
;                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
;ZZZS12                  BTFSS   INTCON, TMR0IF          ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
;                        GOTO    ZZZS12                  ;ES ERFOLGT EIN SPRUNG ZU "DECFSC ZAE, F"..... VORHER ANDERES ABARBEITEN

;                        DECFSZ  HELP1, F                 ;ES WIRD DER WERT IN "HELP" ABWRTS GEZHLT, BIS ER (0) IST UND
;                        GOTO    ZZZS11                   ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS;

;                        DECFSZ  HELP, F
;                        GOTO    ZZZS10    

;                        RETURN

;ZEITBERECHNUNG FUER 5MS
;ACHTUNG HIER BERECHNUNG FR 4MHZ / JETZT 8MHZ ABER PRESCALER 64X

;PRESCALER 32X  *  SYSTEM 4X  * TAKTZEIT ====> 32*4*0.25S=32SEC /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;5MSEC : 32SEC= 156,25  GENOMMEN 156                                   /T = 1 : F  (F)-OSZILLATORFREQUENZ HIER 16MHZ
;ALSO 
;32S*D'156'=4,992MSEC
;TMR0 ALSO D'256'-D'156'=D'100' ENTSPRICHT CA. 5MSEC

;20 DRUCHLUFE ERGEBEN 100MSEC MIT HELP1=20...


;*****************************************************************************
;*                              CA. 40S ZEITSCHLEIFE                        *
;*                              31.10.03                                     *
;*****************************************************************************
MUE40       MOVLW   D'8'
            MOVWF   ZAE1
MSA2        NOP             
            NOP         
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP             ;10*NOPS = 10*0,5SEC=5SEC   5SEC*8=40SEC
            DECFSZ  ZAE1, F
            GOTO    MSA2
            RETURN

;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING1_AUS
                BCF     PORTD, BIT1
                RETURN 
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING1_EIN
                BSF     PORTD, BIT1
                RETURN 
;;;;
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING2_AUS
                BCF     PORTD, BIT0
                BCF     PORTC, BIT3
                RETURN 
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING2_EIN
                BSF     PORTD, BIT0
                BSF     PORTC, BIT3
                RETURN 
;;;;
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING3_AUS
                BCF     PORTC, BIT0
                BCF     PORTC, BIT1
                BCF     PORTC, BIT2
                RETURN 
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING3_EIN
                BSF     PORTC, BIT0
                BSF     PORTC, BIT1
                BSF     PORTC, BIT2
                RETURN 
;;;;
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING4_AUS
                BCF     PORTE, BIT0
                BCF     PORTE, BIT1
                BCF     PORTE, BIT2
                BCF     PORTD, BIT3
                RETURN 
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING4_EIN
                BSF     PORTE, BIT0
                BSF     PORTE, BIT1
                BSF     PORTE, BIT2
                BSF     PORTD, BIT3
                RETURN 
;;;;
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING5_AUS
                BCF     PORTC, BIT4
                BCF     PORTC, BIT5
                BCF     PORTC, BIT6
                BCF     PORTC, BIT7
                RETURN 
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING5_EIN
                BSF     PORTC, BIT4
                BSF     PORTC, BIT5
                BSF     PORTC, BIT6
                BSF     PORTC, BIT7
                RETURN 
;;;;
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING6_AUS
                BCF     PORTD, BIT4
                BCF     PORTD, BIT5
                BCF     PORTD, BIT6
                BCF     PORTB, BIT0
                BCF     PORTB, BIT1
                RETURN 
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING6_EIN
                BSF     PORTD, BIT4
                BSF     PORTD, BIT5
                BSF     PORTD, BIT6
                BSF     PORTB, BIT0
                BSF     PORTB, BIT1
                RETURN 
;;;;
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING7_AUS
                BCF     PORTB, BIT2
                BCF     PORTB, BIT3
                BCF     PORTB, BIT4
                BCF     PORTB, BIT5
                BCF     PORTB, BIT6
                BCF     PORTB, BIT7
                BCF     PORTD, BIT2
                RETURN 
;*****************************************************************************
;*             LED-SCHALTEN-DEM-ENTSPRECHEND SIEHE UNTERHALB                 *
;*****************************************************************************
RING7_EIN
                BSF     PORTB, BIT2
                BSF     PORTB, BIT3
                BSF     PORTB, BIT4
                BSF     PORTB, BIT5
                BSF     PORTB, BIT6
                BSF     PORTB, BIT7
                BSF     PORTD, BIT2
                RETURN 


                        END








